<?php

namespace App\Services\Part;

use RuntimeException;
use App\Models\Part\RAMModel;
use App\Helpers\Part\RAMHelper;
use App\Forms\Part\RAMForm;
use App\Entities\Part\RAMEntity;
use App\Entities\Equipment\ServerPartEntity;
use App\DTOs\Part\RAMDTO;

class RAMService extends PartType1Service
{
    private $_form = null;
    private $_helper = null;
    public function __construct(RAMModel $model)
    {
        parent::__construct($model);
        $this->addClassPaths('RAM');
    }
    public function getDTOClass(): string
    {
        return RAMDTO::class;
    }
    public function createDTO(array $formDatas): RAMDTO
    {
        return new RAMDTO($formDatas);
    }
    public function getEntityClass(): string
    {
        return RAMEntity::class;
    }
    public function getFormService(): RAMForm
    {
        if ($this->_form === null) {
            $this->_form = new RAMForm();
            $this->_form->setAttributes([
                'pk_field'         =>  $this->getPKField(),
                'title_field'      => $this->getTitleField(),
                'table'            => $this->model->getTable(),
                'useAutoIncrement' => $this->model->useAutoIncrement(),
                'class_path' => $this->getClassPaths(false)
            ]);
        }
        return $this->_form;
    }
    public function getHelper(): RAMHelper
    {
        if ($this->_helper === null) {
            $this->_helper = new RAMHelper();
            $this->_helper->setAttributes([
                'pk_field'         =>  $this->getPKField(),
                'title_field'      => $this->getTitleField(),
                'table'            => $this->model->getTable(),
                'useAutoIncrement' => $this->model->useAutoIncrement(),
                'class_path' => $this->getClassPaths(false)
            ]);
        }
        return $this->_helper;
    }
    //기본 기능부분
    protected function getEntity_process(mixed $entity): RAMEntity
    {
        return $entity;
    }
    //List 검색용
    //FormFilter 조건절 처리
    //검색어조건절처리
    //OrderBy 처리
    public function setOrderBy(mixed $field = null, mixed $value = null): void
    {
        $this->model->orderBy('title ASC');
        parent::setOrderBy($field, $value);
    }
    //서버파트관련 작업
    //파트정보가져오기
    public function getPartEntityByServerPart(ServerPartEntity $serverPartEntity): RAMEntity
    {
        //IP정보에서 해당하는 IP가 있으면 가져와서 사용중인지 체크 후 수정
        $entity = $this->getEntity($serverPartEntity->getPartUid());
        if (!$entity instanceof RAMEntity) {
            throw new RuntimeException(static::class . '->' . __FUNCTION__ . "에서 {$serverPartEntity->getPartUid()}에 해당하는 RAMEntity정보를 찾을수없습니다.");
        }
        return $entity;
    }
    public function attachToServerPart(ServerPartEntity $serverPartEntity, array $formDatas = []): RAMEntity
    {
        /** @var RAMEntity $entity IDE에 entity type알려주기*/
        $entity = parent::attachToServerPart($serverPartEntity, $formDatas);
        return $entity;
    }
    public function detachFromServerPart(ServerPartEntity $serverPartEntity, array $formDatas = []): RAMEntity
    {
        /** @var RAMEntity $entity IDE에 entity type알려주기*/
        $entity = parent::detachFromServerPart($serverPartEntity, $formDatas);
        return $entity;
    }
}
